#ifndef _AZNIX_AZMM_PROBE_H_
#define _AZNIX_AZMM_PROBE_H_ 1

#ifdef __cplusplus
extern "C" {
#endif

/* flag used to indicate mapped vs. not in prot : */                                                                                     
#define PROT_MAPPED 0x10000                                                                                                              
#define PROT_LARGE  0x20000                                                                                                              
#define PROT_P2P    0x40000                                                                                                              
#define PROT_INVALID    0x80000                    

/* Returns the state of a page table entry */
int mprobe_prot(
    pid_t pid,
    void *addr,
    int flags);

int format_prot(
    char *stringBuffer,
    unsigned long start,
    unsigned long end,
    int prot);

void print_prot(
    char label[],
    unsigned long start,
    unsigned long end,
    int prot);

unsigned long probeRange(
    pid_t          pid,
    int           *rangeProt,
    unsigned long  rangeStart,
    unsigned long  rangeEnd,
    int            flags,
    unsigned long *l3UnappedPtes,
    unsigned long *l3MappedPtes,
    unsigned long *l4UnmappedPtes,
    unsigned long *l4MappedPtes);

void probeRanges(
    pid_t pid,
    unsigned long  start,
    unsigned long  end,
    int            flags,
    unsigned long *l3UnappedPtes,
    unsigned long *l3MappedPtes,
    unsigned long *l4UnmappedPtes,
    unsigned long *l4MappedPtes);

void report_probe_ranges(
    pid_t pid,
    char label[],
    unsigned long start,
    unsigned long length,
    int flags);

#ifdef __cplusplus
} /* extern "C" */
#endif /* __cplusplus */

#endif /* _AZNIX_AZMM_PROBE_H_ */
