#ifndef _AZPROF_CPU_HPP
#define _AZPROF_CPU_HPP

#include <stdio.h>
#include <stdint.h>

namespace azprof {

class Atomic {
public:
    typedef int64_t Int;

    static Int cas(Int val, volatile Int *dst, Int cmpval) {
        return __sync_val_compare_and_swap(dst, cmpval, val);
    }
    static Int add(Int a, volatile Int *dst) { return __sync_add_and_fetch(dst, a); }
    static Int sub(Int a, volatile Int *dst) { return __sync_add_and_fetch(dst, -a); }
    static Int inc(volatile Int *dst) { return __sync_add_and_fetch(dst, 1); }
    static Int dec(volatile Int *dst) { return __sync_add_and_fetch(dst, -1); }
    static void membar() { __asm__ __volatile__ ("mfence":::"memory"); }

private:
    Atomic();
};

class CPU {
public:
    static const char* perfcnt_event_name(int);

private:
    CPU();
};

}; // namespace azprof

#endif // _AZPROF_CPU_HPP
