// Copyright 2003 Azul Systems, Inc. All rights reserved.
// AZUL Systems PROPRIETARY/CONFIDENTIAL. Use is subject to license terms

// system_config.h - Azul OS system services.

#ifndef _OS_CONFIG_H_
#define _OS_CONFIG_H_ 1

#ifdef __cplusplus
extern "C" {
#endif

#include <os/types.h>

extern sys_return_t system_configuration(uint64_t  _what,
					 address_t _buffer,
					 size_t    _buffer_size);

// Get the system configuration information.

struct sysconf_frequency {
	uint64_t sysc_numerator;
	uint64_t sysc_denominator;
    double   sysc_hz;
};

#define	SYSTEM_CONFIGURATION_CPU_FREQUENCY	0x1

// If SYSTEM_CONFIGURATION_CPU_FREQUENCY is passed in as "what", the
// frequency of the CPU is returned in "buffer". In this case 
// "buffer_size" should be sizeof(struct sysconf_frequency).
// 
// Error codes returned:
// SYSERR_NONE: Success.
// SYSERR_INVALID_ARGUMENT: Invalid "what" or "buffer_size" value.
// SYSERR_INVALID_ADDRESS: "buffer" pointer is bad.
// SYSERR_PROTECTION_FAILURE: "buffer" address is on a write
//                         protected page.
// SYSERR_INVALID_STATE: On linux systems, reading /proc/cpuinfo 
//                       or parsing MHz failed

// system_timestamp_counter_frequency_estimate
// Determining the TSC frequency should only be done for the VMware
// environment where the TSC that we are reading is a virtual TSC.

#ifdef __cplusplus
} // extern "C"
#endif

#endif // _OS_CONFIG_H_
