// Copyright 2003 Azul Systems, Inc. All rights reserved.
// AZUL Systems PROPRIETARY/CONFIDENTIAL. Use is subject to license terms

// lock.h - Azul locks

#ifndef _OS_LOCK_H_
#define _OS_LOCK_H_ 1

#include <pthread.h>

#ifdef __cplusplus
extern "C" {
#endif

#define OS_SPIN_LOCK_T                  pthread_mutex_t
#define OS_SPIN_LOCK_INITIALIZER        PTHREAD_MUTEX_INITIALIZER

#define OS_SPIN_LOCK_INIT(this_lock)    pthread_mutex_init(this_lock, NULL)
#define OS_SPIN_TRYLOCK(this_lock)      pthread_mutex_trylock(this_lock)
#define OS_SPIN_LOCK(this_lock)         pthread_mutex_lock(this_lock)
#define OS_SPIN_UNLOCK(this_lock)       pthread_mutex_unlock(this_lock)

#ifdef __cplusplus
} // extern "C"
#endif

#endif // _OS_LOCK_H_
